var selectedProvider;
var items;
var currentFirstItem;
var pageSize;
var currentItem;

function init()
{
	selectedProvider = readCurrentSetting();
	pageSize = 5;

    System.Gadget.settingsUI = "settings.html";
    System.Gadget.onSettingsClosed = settingsClosed;
}

function loadSettings() 
{
	System.Gadget.onSettingsClosing = settingsClosing;

//	providerName.options[0] = new Option("Anthology", "http://www.anthology.si/opensearch.ashx?q=");
	providerName.options[0] = new Option("SLODUG/Codezone-SI", "http://www.codezone-si.info/search/Searchrss.aspx?o=Relevance&q=");
	providerName.options[1] = new Option("MSDN", "http://lab.msdn.microsoft.com/search/data.ashx?query=");
	providerName.options[2] = new Option("MSDN Blogs", "http://blogs.msdn.com/search/Searchrss.aspx?o=Relevance&q=");
	providerName.options[3] = new Option("ASP.NET Forums", "http://forums.asp.net/search/Searchrss.aspx?o=Relevance&q=");
	providerName.options[4] = new Option("Amazon books", "http://a9.com/-/feeds/awsOpenSearchData.jsp?store=Books&format=rss&q=");
	providerName.value = readCurrentSetting()
}

function settingsClosing(event)
{
	if (event.closeAction == event.Action.commit) 
    {
		System.Gadget.Settings.write("selectedProvider", providerName.value);
	}
	
	event.cancel = false;
}

function settingsClosed() 
{
	selectedProvider = readCurrentSetting();
	search();
}

function readCurrentSetting()
{
	var currentSetting = System.Gadget.Settings.read("selectedProvider");
	if (currentSetting == "")
    	currentSetting = "http://www.codezone-si.info/search/Searchrss.aspx?o=Relevance&q=";
	return currentSetting;
}

function rssChannelItem(title, link, description)
{
    this.title = title;
    this.link = link;
    this.description = description;
}

function search()
{
	if (keywords.value != "")
	{
		items = getItems(selectedProvider+keywords.value);
		currentFirstItem = 0;
		displayResults();
	}
}

function movePrevious()
{
	currentFirstItem = currentFirstItem - pageSize;
	if (currentFirstItem < 0)
	{
		currentFirstItem = items.length - 1 - ((items.length-1) % pageSize) * pageSize;
	}
	displayResults();
}

function moveNext()
{
	currentFirstItem = currentFirstItem + pageSize;
	if (currentFirstItem > items.length-1)
	{
		currentFirstItem = 0;
    }
	displayResults();
}

function displayResults()
{
    var currentLastItem = currentFirstItem + pageSize;
	if (currentLastItem > items.length)
	{
		currentLastItem = items.length;
	}

	var table = '<table cellpadding="0" cellspacing="0">';
	for (var i = currentFirstItem; i < currentLastItem; i++)
	{
        table += '<tr><td><a class="item" href="" onclick="showFlyout(' + i + ');" title="' + items[i].title +'">' + items[i].title + '</a></td></tr>';
    }
	table += '</table>';
	document.getElementById("content").innerHTML = table;
	document.getElementById("positionNumbers").innerHTML = (currentFirstItem+1) + "/" + currentLastItem;
}

function getItems(url)
{
	var rssFeed = new ActiveXObject("Microsoft.XMLDOM");
	rssFeed.async = false;
	rssFeed.load(url);

	var rssNodes = rssFeed.selectNodes("//rss/channel/item");
	totalItems = rssNodes.Length;

	var rssNode = rssNodes.nextNode();

	var maxItemCount = 100;
	var i = 0;
	var items = new Array();
	while (rssNode != null && i < maxItemCount)
	{
        items[i] = new rssChannelItem(rssNode.childNodes[0].text, rssNode.childNodes[1].text, rssNode.selectSingleNode("description").text);
        rssNode = rssNodes.nextNode();
		i++;
	}
	return items;
}

function initFlyout()
{
    var currentItem = System.Gadget.document.parentWindow.getCurrentItem();
    description.innerHTML = currentItem.description;
    title.href = currentItem.link;
    title.innerHTML = currentItem.title;
    document.body.focus();
}

function showFlyout(itemIndex)
{ 
    currentItem = itemIndex;
    System.Gadget.Flyout.file = "flyout.html";
    if (System.Gadget.Flyout.show == false)
    { 
        System.Gadget.Flyout.show = true;
    }
        
    if ( window.event != null ) 
    { 
        window.event.returnValue = false; 
    } 
} 

function getCurrentItem()
{
    return items[currentItem];
}

function showAboutBox()
{ 
    System.Gadget.Flyout.file = "about.html"
    if (System.Gadget.Flyout.show == false)
    { 
        System.Gadget.Flyout.show = true;
    }
        
    if ( window.event != null ) 
    { 
        window.event.returnValue = false; 
    } 
} 